﻿;/ Created with PureVision64 v6.00 x64
;/ Tue, 13 Sep 2022 19:26:44
;/ by Frank Haberditzl                

EnableExplicit

DataSection
  HelpIcon:
    IncludeBinary "Images\book.ico"
  HelpIconEnd:
  
;   Separator1:
;     IncludeBinary "Images\Separator1.jpg"
;   Separator1End:
EndDataSection

XIncludeFile "StringFilterUI_Constants.pb"
XIncludeFile "StringFilterUI_Windows.pb"

XIncludeFile "AppTypes.pbi"
XIncludeFile "..\Common includes\CommonProcedures.pbi"
XIncludeFile "..\Common includes\Ini.pbi"

Global.i CurrentValue, ManualImg
Global Value$, CurrentBasePath$

Define.i Manual$

Global StringFilter.StringFilter_Type

Global NewList ToFilter.ToFilter_Type()

Global NewList PreviousHitLine$()

Global NewList DetectedHit.DetectedHit_Type()

XIncludeFile "RunMode.pbi"

Procedure.i AddHitMessage(ThisMessage$)
  If (IsWindow(#Window_StringFilterTool) <>  0)
    AddGadgetItem(#Gadget_StringFilterTool_HitInformationEditor, -1, ThisMessage$)
    ShowEditGadgetLastLine(#Gadget_StringFilterTool_HitInformationEditor)
    ProcedureReturn 1
  EndIf
  
  ProcedureReturn 0
EndProcedure

Procedure.i AddFilteredHitPathMessage(HitPath$)
  If (GetGadgetState(#Gadget_StringFilterTool_RemoveBasePathCheckBox) = #PB_Checkbox_Checked)
    If (Len(HitPath$) > Len(StringFilter\PictureArchiveLocation$))
      HitPath$ = Right(HitPath$, Len(HitPath$) - Len(StringFilter\PictureArchiveLocation$) - 1)
    EndIf
  EndIf
  
  ProcedureReturn AddHitMessage(HitPath$)
EndProcedure

; register a gadget to the runmode system

; RawFileName$ = filename including the full path including the windows drive 

Procedure.i RememberHit(RawFileName$, MPHName$)
  Define.i FileID, Result
  
  Result = -1
  
  FileID = ReadFile(#PB_Any, RawFileName$)
  If (FileID <> 0)
    CloseFile(FileID)
    FileID = 0
    Result = 1
  EndIf
  
  If (AddElement(DetectedHit()) <> 0)
    DetectedHit()\FileName$ = RawFileName$
    DetectedHit()\MPHName$ = MPHName$
  Else
    Result = -2
  EndIf
  
  ProcedureReturn Result
EndProcedure

Procedure.i AddInfoMessage(ThisMessage$)
  If (IsWindow(#Window_StringFilterTool) <>  0)
    AddGadgetItem(#Gadget_StringFilterTool_InfoEditor, -1, ThisMessage$)
    ShowEditGadgetLastLine(#Gadget_StringFilterTool_InfoEditor)
    ProcedureReturn 1
  EndIf
  
  ProcedureReturn 0
EndProcedure

Procedure Init()
  Define.i FSize
  
  StringFilter\MPHLocation$ = "C:\Users\haber\Documents\MAGIX\Photostory Deluxe"
;  StringFilter\MPHLocation$ = "d:\mphtest"
  StringFilter\PictureArchiveLocation$ = "D:\Familienbilder Stand Juni 2022"
  StringFilter\MinimumStringLength = Len(StringFilter\PictureArchiveLocation$)
  
  ; register all possible gadgets of this application
  
  ; runmode 1 - configuration
  RunMode::RegisterGadget(1, #Gadget_StringFilterTool_AppContainer1, "", RunMode::#GADGET_IS_CONTAINER)
  RunMode::RegisterGadget(1, #Gadget_StringFilterTool_MPHDirectoryText)
  RunMode::RegisterGadget(1, #Gadget_StringFilterTool_MPHDirectoryButton)
  RunMode::RegisterGadget(1, #Gadget_StringFilterTool_BasePathText)
  RunMode::RegisterGadget(1, #Gadget_StringFilterTool_BasePathButton)
  RunMode::RegisterGadget(1, #Gadget_StringFilterTool_MinimumStringLengthText)
  RunMode::RegisterGadget(1, #Gadget_StringFilterTool_MinimumStringLengthTrackBar)
  RunMode::RegisterGadget(1, #Gadget_StringFilterTool_StringLengthText)
  RunMode::RegisterGadget(1, #Gadget_StringFilterTool_RequireBasePathCheckBox)
  RunMode::RegisterGadget(1, #Gadget_StringFilterTool_RemoveBasePathCheckBox)
  RunMode::RegisterGadget(1, #Gadget_StringFilterTool_PrependMPHNameCheckBox)
  RunMode::RegisterGadget(1, #Gadget_StringFilterTool_ActionButton)
  RunMode::RegisterGadget(1, #Gadget_StringFilterTool_ManualButtonImage1, #APPNAME + ".chm")
  
  ; runmode 2 - execution
  
  RunMode::RegisterGadget(2, #Gadget_StringFilterTool_AppContainer2, "", RunMode::#GADGET_IS_CONTAINER)
  RunMode::RegisterGadget(2, #Gadget_StringFilterTool_InfoFrame)
  RunMode::RegisterGadget(2, #Gadget_StringFilterTool_InfoEditor)
  RunMode::RegisterGadget(2, #Gadget_StringFilterTool_ProgressBar)
  RunMode::RegisterGadget(2, #Gadget_StringFilterTool_HitFrame)
  RunMode::RegisterGadget(2, #Gadget_StringFilterTool_HitInformationEditor)
  RunMode::RegisterGadget(2, #Gadget_StringFilterTool_SaveResultsButton)
  RunMode::RegisterGadget(2, #Gadget_StringFilterTool_ManualButtonImage2, #APPNAME + ".chm")
  
  SetGadgetAttribute(#Gadget_StringFilterTool_MinimumStringLengthTrackBar, #PB_TrackBar_Minimum, 8)
  SetGadgetAttribute(#Gadget_StringFilterTool_MinimumStringLengthTrackBar, #PB_TrackBar_Maximum, 40)
  SetGadgetState(#Gadget_StringFilterTool_MinimumStringLengthTrackBar, StringFilter\MinimumStringLength)
  SetGadgetText(#Gadget_StringFilterTool_MPHDirectoryButton, StringFilter\MPHLocation$)
  SetGadgetText(#Gadget_StringFilterTool_BasePathButton, StringFilter\PictureArchiveLocation$)
  
  StringFilter\ManualImg = CatchImage(#PB_Any, ?HelpIcon, ?HelpIconEnd - ?HelpIcon)
  If (StringFilter\ManualImg = 0)
    Debug "Minor error - catching the help button icon failed"
  EndIf
  
  FSize = FileSize("strings64.exe")
  
  If (FSize < 0)
    MessageRequester("Fataler Fehler", "Bitte kopieren Sie das Sysinternals Tool" + Chr($a) + "'strings64.exe' in das Verzeichnis zu " + GetFilePart(ProgramFilename()), #PB_MessageRequester_Error | #PB_MessageRequester_Ok)
    RunProgram("https://learn.microsoft.com/en-us/sysinternals/downloads/strings", "", GetCurrentDirectory())
    End 999
  EndIf
  
  ;  Debug "init range = " + Str(GetGadgetAttribute(#Gadget_StringFilterTool_MinimumStringLengthTrackBar, #PB_TrackBar_Minimum)) + " - " + Str(GetGadgetAttribute(#Gadget_StringFilterTool_MinimumStringLengthTrackBar, #PB_TrackBar_Maximum))
  
  ExamineDesktops()
  
EndProcedure

Procedure GetPreviousWindowPos()
  Define.i IniHandle, WinWidth, WinHeight
  Define.i XPos, YPos
  Define WindowInfo$
  
  IniHandle = OpenINI(#APPNAME + ".ini", #INI_NoSpace | #INI_UseLF | #INI_NoBOM)
  If (IniHandle)
    
    INIGroup(IniHandle, "General")

    If (IsWindow(#Window_StringFilterTool) <> 0)
      WindowInfo$ = ReadINIString(IniHandle, "MainWindowPosition")
      If (WindowInfo$ <> "")
        WinWidth = ClipNumber(Val(StringField(WindowInfo$, 3, ",")), 320, DesktopWidth(0))
        WinHeight = ClipNumber(Val(StringField(WindowInfo$, 4, ",")), 200, DesktopHeight(0))
        XPos = ClipNumber(Val(StringField(WindowInfo$, 1, ",")), 0, (DesktopWidth(0) - WinWidth))
        YPos = ClipNumber(Val(StringField(WindowInfo$, 2, ",")), 0, (DesktopHeight(0) - WinHeight))
      
        ResizeWindow(#Window_StringFilterTool, XPos, YPos, WinWidth, WinHeight)
      EndIf
    EndIf
    
    CloseINI(IniHandle)
  EndIf
  
EndProcedure

Procedure MainWindow_Update()
  SetGadgetText(#Gadget_StringFilterTool_StringLengthText, Str(GetGadgetState(#Gadget_StringFilterTool_MinimumStringLengthTrackBar)))
EndProcedure

Procedure.i DoesFileExist(FileName$)
  Define Directory$, CurrentFileName$, TestFileName$
  Define.i FLen, DirID
  
;  FileName$ = LCase(FileName$)
  TestFileName$ = LCase(GetFilePart(FileName$))

  Directory$ = GetPathPart(FileName$)
  If (Right(Directory$, 1) = "\")
    Directory$ = Left(Directory$, Len(Directory$) - 1)
  EndIf
  
;  SetCurrentDirectory("d:\")
  DirID = ExamineDirectory(#PB_Any, Directory$, "*.*")
  If (DirID = 0)
    AddInfoMessage("Error examining the path '" + Directory$ + "'")
    ProcedureReturn 0
  EndIf
  
  While NextDirectoryEntry(DirID)
    If DirectoryEntryType(DirID) = #PB_DirectoryEntry_File
      CurrentFileName$ = LCase(DirectoryEntryName(DirID))
;      Debug "'" + TestFileName$ + "' = '" + CurrentFileName$ + "' ?"
      If (TestFileName$ = CurrentFileName$)
        FinishDirectory(DirID)
        ProcedureReturn 1
      EndIf
    EndIf
  Wend
  FinishDirectory(DirID)
  
;   FLen = FileSize(LCase(TestFileName$))
;   If (FLen >= 0)
;     ProcedureReturn 1
;   EndIf
  
  ProcedureReturn 0
EndProcedure

Procedure.i AlreadyAdded(CurrentLine$)
  ForEach PreviousHitLine$()
    If (PreviousHitLine$() = CurrentLine$)
      ProcedureReturn 1
    EndIf
  Next
  
  ProcedureReturn 0
EndProcedure

Procedure.s NormalizePath(InputPath$)
  Define.i TotalChunks
  Define.i f
  Define c$, NextChunk$, Result$
  
  TotalChunks = CountString(InputPath$, "/")
  If (TotalChunks = 0)
    ProcedureReturn InputPath$
  EndIf
  
  Result$ = ""
  For f = 1 To (TotalChunks + 1)
    NextChunk$ = StringField(InputPath$, f, "/")
    If (Result$ <> "")
      Result$ + "\"
    EndIf
    
    Result$ + NextChunk$
  Next
  
  ProcedureReturn Result$
  
EndProcedure

Procedure.s SanitizeFileEnding(RawFileName$, AllowedExtensions$)
  Define.i TotalExtensions, FoundPosition, FLen
  Define.i f
  Define.q FSize
  Static.i ExecutionNumber = 0
  Define FileName$, CurrentExtension$, PossibleFileName$
  Define NewMPHName$
  Define c$
  
;  If (FindString(LCase(RawFileName$), "dsc_4938.jpg") <> 0)
;    Debug "bazinga"
;  EndIf
  
  ExecutionNumber + 1
  
;  Debug "Sanitize #" + Str(ExecutionNumber) + " '" + RawFileName$ + "'"
  FileName$ = LCase(GetFilePart(RawFileName$))
  
  TotalExtensions = CountString(AllowedExtensions$, ",") + 1
  For f = 1 To TotalExtensions
    CurrentExtension$ = "." + StringField(AllowedExtensions$, f, ",")
    FoundPosition = FindString(FileName$, CurrentExtension$)
    If (FoundPosition <> 0)
      PossibleFileName$ = GetPathPart(RawFileName$) + Left(FileName$, FoundPosition + Len(CurrentExtension$) - 1)
      FSize = FileSize(PossibleFileName$)
      
      ; this might be a legitimate file - lets see if it actually exists
      
      If ((DoesFileExist(PossibleFileName$) > 0) And (AlreadyAdded(PossibleFileName$) = 0))
        RememberHit(PossibleFileName$, StringFilter\CurrentMPHFile$)
        AddFilteredHitPathMessage(PossibleFileName$)
        AddElement(PreviousHitLine$())
        PreviousHitLine$() = PossibleFileName$
      EndIf
      
;       Flen = Len(PossibleFileName$)
;       For f = 1 To Flen
;         c$ = Mid(PossibleFileName$, f, 1)
;         Debug "#" + Str(f) + " = " + Asc(c$) + " '" + c$ + "'"
;       Next
      
      If (FSize >= 0)
        ProcedureReturn PossibleFileName$
      EndIf
    EndIf
  Next
  
  ProcedureReturn ""
EndProcedure

Procedure.i DumpBuffer(FileName$, *Buffer, BufferSize.i)
  Define.i FileID, Result, FSize
  
;  FileName$ = "d:\bufferdump.bin"
  Result = -1
  FSize = FileSize(FileName$)
  
  If (FSize = -1)
    
    FileID = CreateFile(#PB_Any, FileName$)
    If (FileID = 0)
      Result = -2
    Else
      FileBuffersSize(FileID, 0)
      If (WriteData(FileID, *Buffer, BufferSize) = BufferSize)
        CloseFile(FileID)
        Result = 1
      Else
        CloseFile(FileID)
        DeleteFile(FileName$)
        Result = -3
      EndIf
    EndIf
  EndIf
  
  ProcedureReturn Result
EndProcedure

Procedure.s FilterFile(FileName$, MinimumStringLength.i, PictureArchiveLocation$)
  Define.i FilterProgram, BasePathLength, Result
  Define.i Exitcode, TotalLines, DidShowMPHName
  Define.i f
  Define c$
  Define CurrentLine$ , Output$, Path$
  
  StringFilter\CurrentMPHFile$ = FileName$
  PictureArchiveLocation$ = LCase(PictureArchiveLocation$)
  
  If (GetGadgetState(#Gadget_StringFilterTool_PrependMPHNameCheckBox) = #PB_Checkbox_Checked)
    AddHitMessage("; " + GetFilePart(FileName$))
  EndIf
        
  Result = -1
  
  If (Right(PictureArchiveLocation$, 1) <> "\")
    PictureArchiveLocation$ + "\"
  EndIf
  
  BasePathLength = Len(PictureArchiveLocation$)
  
  Result = 0
  FilterProgram = RunProgram(GetCurrentDirectory() + "strings64.exe", "-nobanner -n " + Str(MinimumStringLength) + " " + Chr(34) + FileName$+ Chr(34), GetCurrentDirectory(), #PB_Program_Open | #PB_Program_Read | #PB_Program_Hide)
  
  If (FilterProgram <> 0)
    
    Output$ = ""
    While ProgramRunning(FilterProgram)
      If AvailableProgramOutput(FilterProgram)
        Output$ + ReadProgramString(FilterProgram) + Chr(13)
      Else
        Delay(10)
      EndIf
    Wend
    Output$ + Chr(13) + Chr(13)
    Exitcode = ProgramExitCode(FilterProgram)
    
;    Debug "-- " + GetFilePart(FileName$) + " code = " + Str(Exitcode) 
;    Debug "Raw output :"
;    Debug Output$
    
    CloseProgram(FilterProgram)
  EndIf
  
;   Result = DumpBuffer("d:\Bufferdump_" + GetFilePart(FileName$) + ".bin", @Output$, StringByteLength(Output$))
;   If (Result <> 1)
;     Debug "warning - dumpbuffer result = " + Str(Result)
;   EndIf
  
  TotalLines = CountString(Output$, Chr(13))
  DidShowMPHName = 0
  
;  CurrentLine$ = SanitizeFileEnding("lala.jpgi", #VALIDMEDIAEXTENSIONS)
  
  ; now filter the resulting output
;  Debug "ArchiveLocation (" + Str(BasePathLength) + " '" + PictureArchiveLocation$ + "'"
  
  For f = 1 To TotalLines
    CurrentLine$ = NormalizePath(StringField(Output$, f, Chr(13)))
;     Debug "#" + Str(f) + " '" + CurrentLine$ + "'"
    Path$ = LCase(Left(CurrentLine$, BasePathLength))
;     Debug "step 1 (" + Str(BasePathLength) + " '" + Path$ + "'"
;     Debug "step 2 (" + Str(BasePathLength) + " '" + CurrentLine$ + "'"
;     Debug "step 3 (" + Str(BasePathLength) + " '" + PictureArchiveLocation$ + "'"
    If (Path$ = PictureArchiveLocation$)
;    If (LCase(Left(CurrentLine$, BasePathLength)) = PictureArchiveLocation$)
;      Debug "step 4 '" + CurrentLine$ + "'"
      CurrentLine$ = SanitizeFileEnding(CurrentLine$, #VALIDMEDIAEXTENSIONS)
      If ((CurrentLine$ <> "") And (AlreadyAdded(CurrentLine$) = 0))
;        Debug "checkbox = " + Hex(GetGadgetState(#Gadget_StringFilterTool_PrependMPHNameCheckBox)) + " / " + Hex(#PB_Checkbox_Checked)
        RememberHit(CurrentLine$, StringFilter\CurrentMPHFile$)
;       AddFilteredHitPathMessage(CurrentLine$)
        AddElement(PreviousHitLine$())
        PreviousHitLine$() = CurrentLine$
      EndIf
    EndIf
  Next
  
  ProcedureReturn Output$
EndProcedure

Procedure.i ClearWindowMsgQueue()
  Define.i NumIgnoredEvents, CurrentEvent
  
  NumIgnoredEvents = 0
  
  Repeat
    CurrentEvent = WindowEvent()
    
    If (CurrentEvent <> 0)
      NumIgnoredEvents + 1
    EndIf
  Until (CurrentEvent = 0)
  
  ProcedureReturn NumIgnoredEvents
EndProcedure

Procedure FindMultipleUseFiles()
  Define CurrentPath$, FirstMPH$  
  Define.i LoopState
  
  SortStructuredList(DetectedHit(), #PB_Sort_Ascending | #PB_Sort_NoCase, OffsetOf(DetectedHit_Type\FileName$), #PB_String)
  
  LoopState = 0
  CurrentPath$ = ""
  ForEach DetectedHit()
    Select LoopState
      Case 0
        If ((CurrentPath$ <> "") And (CurrentPath$ = DetectedHit()\FileName$))
          LoopState = 1
        Else
          CurrentPath$ = DetectedHit()\FileName$
          FirstMPH$ = DetectedHit()\MPHName$
        EndIf
        
      Case 1  ; we found another entry with the same path
        LoopState = 2
        AddInfoMessage(CurrentPath$)
        AddInfoMessage("   " + FirstMPH$)
        AddInfoMessage("   " + DetectedHit()\MPHName$)
        
      Case 2 ; 
        If ((CurrentPath$ <> "") And (CurrentPath$ = DetectedHit()\FileName$))
          AddInfoMessage("   " + DetectedHit()\MPHName$)
        Else
          LoopState = 0
          CurrentPath$ = DetectedHit()\FileName$
          FirstMPH$ = DetectedHit()\MPHName$
        EndIf
    EndSelect
    
  Next
  
EndProcedure

Procedure StartFiltering()
  Define.i MPHDirectoryID, Result, TotalMPHFiles
  Define.i CurrentMPHFile
  Define MPHDirectory$, BasePictureDirectory$
  
  MPHDirectory$ = GetGadgetText(#Gadget_StringFilterTool_MPHDirectoryButton)
  BasePictureDirectory$ = GetGadgetText(#Gadget_StringFilterTool_BasePathButton)
  
  ClearGadgetItems(#Gadget_StringFilterTool_HitInformationEditor)
  
  TotalMPHFiles = GetNumberOfFiles(MPHDirectory$, "*.mph")
  
  Result = -1

  MPHDirectoryID = ExamineDirectory(#PB_Any, MPHDirectory$, "*.mph")
  If (MPHDirectoryID <> 0)
    Result = 1
    
    DisableGadget(#Gadget_StringFilterTool_ActionButton, #True)
    
    AddInfoMessage("Es wird gesucht unter '" + MPHDirectory$ + "' nach treffern in '" + BasePictureDirectory$ + "'")
    
    ClearList(ToFilter())

    ClearList(PreviousHitLine$())
    
    While NextDirectoryEntry(MPHDirectoryID)
      If DirectoryEntryType(MPHDirectoryID) = #PB_DirectoryEntry_File
        AddElement(ToFilter())
        ToFilter()\FileName$ = MPHDirectory$ + "\" + DirectoryEntryName(MPHDirectoryID)
        ToFilter()\Size = DirectoryEntrySize(MPHDirectoryID)
      EndIf
      ClearWindowMsgQueue()
    Wend
    FinishDirectory(MPHDirectoryID)
    
    ClearList(DetectedHit())
    
    SetGadgetAttribute(#Gadget_StringFilterTool_ProgressBar, #PB_ProgressBar_Minimum, 0)
    SetGadgetAttribute(#Gadget_StringFilterTool_ProgressBar, #PB_ProgressBar_Maximum, TotalMPHFiles)
    
    CurrentMPHFile = 0
    ForEach(ToFilter())
      AddInfoMessage("Filtering '" + ToFilter()\FileName$ + "'")
      FilterFile(ToFilter()\FileName$, StringFilter\MinimumStringLength, StringFilter\PictureArchiveLocation$)
      SetGadgetState(#Gadget_StringFilterTool_ProgressBar, CurrentMPHFile)
      ClearWindowMsgQueue()
      CurrentMPHFile + 1
    Next
    SetGadgetState(#Gadget_StringFilterTool_ProgressBar, TotalMPHFiles)
    
    AddInfoMessage("Done")
    FindMultipleUseFiles()
    DisableGadget(#Gadget_StringFilterTool_ActionButton, #False)
  EndIf

  ProcedureReturn Result
EndProcedure

Procedure ResizedMainWindow()
  Define.i ButtonWidth, NewButtonX
  
  ButtonWidth = GadgetWidth(#Gadget_StringFilterTool_ActionButton)
  NewButtonX = (WindowWidth(#Window_StringFilterTool) - ButtonWidth) / 2
  
;  Debug Str(ButtonWidth) + " / " + Str(WindowWidth(#Window_StringFilterTool)) + " results in pos x = " + Str(NewButtonX)
  
  ResizeGadget(#Gadget_StringFilterTool_ActionButton, NewButtonX, #PB_Ignore, #PB_Ignore, #PB_Ignore)
  
EndProcedure

; write current program settings like window position into .ini file

Procedure StoreProgramSettingsToIni()
  Define.i IniHandle
  
  IniHandle = CreateINI(#APPNAME + ".ini", #INI_NoSpace | #INI_UseLF | #INI_NoBOM)
  If (IniHandle)
    INIGroup(IniHandle, "General")
    If (IsWindow(#Window_StringFilterTool) <> 0)
      Value$ = Str(WindowX(#Window_StringFilterTool)) + "," + Str(WindowY(#Window_StringFilterTool)) + "," + Str(WindowWidth(#Window_StringFilterTool)) + "," + Str(WindowHeight(#Window_StringFilterTool))
      WriteINIString(IniHandle, "MainWindowPosition", Value$)
    EndIf
    CloseINI(IniHandle)
    
    ProcedureReturn -1
  EndIf
  
  ProcedureReturn 1
  
EndProcedure

;  1 - everything ok, a result file was successfully created and written
; -1 - failed
; -2 - failure during writing of file, resulting file was removed

Procedure.i SaveCurrentHits()
  Define.i FileID
  Define Results$, HitsFileName$
  
  Results$ = GetGadgetText(#Gadget_StringFilterTool_HitInformationEditor)
  HitsFileName$ = SaveFileRequester("Ergebnis speichern", #APPNAME + "_Hits.txt", "Text *.txt", 0)
  
  If (HitsFileName$ <> "")
    FileID = CreateFile(#PB_Any, HitsFileName$)
    
    If (FileID <> 0)
      WriteStringFormat(FileID, #PB_UTF8)
      If (WriteStringN(FileID, Results$, #PB_UTF8) = 0)
        CloseFile(FileID)
        DeleteFile(HitsFileName$)
        ProcedureReturn -2
      EndIf
      
      CloseFile(FileID)
      ProcedureReturn 1
    EndIf
    
  EndIf
  
  ProcedureReturn -1
  
EndProcedure

;- Main Loop
If Window_StringFilterTool()
  
  Init()
  MainWindow_Update()
  RunMode::UpdateUI(1)
  BindEvent(#PB_Event_SizeWindow, @ResizedMainWindow())
  GetPreviousWindowPos()
  If (StringFilter\ManualImg <> 0)
    SetGadgetAttribute(#Gadget_StringFilterTool_ManualButtonImage1, #PB_Button_Image , ImageID(StringFilter\ManualImg))
    SetGadgetAttribute(#Gadget_StringFilterTool_ManualButtonImage1, #PB_Button_PressedImage , ImageID(StringFilter\ManualImg))
  EndIf
  
;  Debug "doesfile exist = " + Str(DoesFileExist("D:\Familienbilder Stand September 2022\Ereignis\Urlaub Clausthal-Zellerfeld 2022\Fotos und Videos gemacht von\Fam. Holz\1C5B870B-B3DB-4AE3-A901-2AE8E1E46F19.jpeg"))
  
  Define quitStringFilterTool=0
  Repeat
    EventID  =WaitWindowEvent()
    MenuID   =EventMenu()
    GadgetID =EventGadget()
    WindowID =EventWindow()

    Select EventID
      Case #PB_Event_CloseWindow
        Select WindowID
          Case #Window_StringFilterTool
            quitStringFilterTool=1
        EndSelect


      Case #PB_Event_Gadget
        Select GadgetID
          Case #Gadget_StringFilterTool_MPHDirectoryButton
            Value$ = PathRequester("Bitte das Verzeichnis mit den Photostory MPH Dateien wählen", StringFilter\MPHLocation$)
            If (Value$ <> "")
              StringFilter\MPHLocation$ = Value$
            EndIf
            MainWindow_Update()
            
          Case #Gadget_StringFilterTool_BasePathButton
          Case #Gadget_StringFilterTool_MinimumStringLengthTrackBar
            CurrentValue = GetGadgetState(#Gadget_StringFilterTool_MinimumStringLengthTrackBar)
            StringFilter\MinimumStringLength = GetGadgetState(#Gadget_StringFilterTool_MinimumStringLengthTrackBar)
            MainWindow_Update()
            
          Case #Gadget_StringFilterTool_RequireBasePathCheckBox
            If (GetGadgetState(#Gadget_StringFilterTool_RequireBasePathCheckBox) = #PB_Checkbox_Checked)
              CurrentBasePath$ = GetGadgetText(#Gadget_StringFilterTool_BasePathButton)
              SetGadgetState(#Gadget_StringFilterTool_MinimumStringLengthTrackBar, Len(CurrentBasePath$))
              
;              Debug "min length trackbar " + Str(GetGadgetState(#Gadget_StringFilterTool_MinimumStringLengthTrackBar)) + " / " + Str(Len(CurrentBasePath$))
;              Debug "range = " + Str(GetGadgetAttribute(#Gadget_StringFilterTool_MinimumStringLengthTrackBar, #PB_TrackBar_Minimum)) + " - " + Str(GetGadgetAttribute(#Gadget_StringFilterTool_MinimumStringLengthTrackBar, #PB_TrackBar_Maximum))
              If (GetGadgetState(#Gadget_StringFilterTool_MinimumStringLengthTrackBar) < Len(CurrentBasePath$))
                SetGadgetState(#Gadget_StringFilterTool_MinimumStringLengthTrackBar, Len(CurrentBasePath$))
              EndIf
            Else
              SetGadgetAttribute(#Gadget_StringFilterTool_MinimumStringLengthTrackBar, #PB_TrackBar_Minimum, 8)
            EndIf
            MainWindow_Update()
            
          Case #Gadget_StringFilterTool_RemoveBasePathCheckBox
            
          Case #Gadget_StringFilterTool_ActionButton
            RunMode::UpdateUI(2)
            If (StringFilter\ManualImg <> 0)
              SetGadgetAttribute(#Gadget_StringFilterTool_ManualButtonImage2, #PB_Button_Image , ImageID(StringFilter\ManualImg))
              SetGadgetAttribute(#Gadget_StringFilterTool_ManualButtonImage2, #PB_Button_PressedImage , ImageID(StringFilter\ManualImg))
            EndIf

            DisableGadget(#Gadget_StringFilterTool_SaveResultsButton, #True)
            StartFiltering()
            DisableGadget(#Gadget_StringFilterTool_SaveResultsButton, #False)
            
          Case #Gadget_StringFilterTool_InfoEditor
            
          Case #Gadget_StringFilterTool_SaveResultsButton
            If (SaveCurrentHits() = 1)
              MessageRequester("Success", "The results where successfully saved.", #PB_MessageRequester_Info | #PB_MessageRequester_Ok)
            EndIf
            
          Case #Gadget_StringFilterTool_ManualButtonImage1, #Gadget_StringFilterTool_ManualButtonImage2
            Manual$ = RunMode::GetRequiredFile(GadgetID)
            
            If (Manual$ <> "")
              RunProgram(Manual$, "", GetCurrentDirectory())
            EndIf
                
        EndSelect

    EndSelect
  Until quitStringFilterTool
  StoreProgramSettingsToIni()
  CloseWindow(#Window_StringFilterTool)
EndIf
End

; IDE Options = PureBasic 6.00 LTS (Windows - x64)
; CursorPosition = 130
; FirstLine = 94
; Folding = ----
; EnableThread
; EnableXP
; DPIAware
; CompileSourceDirectory
; Compiler = PureBasic 6.00 LTS (Windows - x64)